io_uring_prep_writev_fixed(3)

NAME
io_uring_prep_writev_fixed - prepare a vectored write using fixed buffers

SYNOPSIS
#include <liburing.h>

void io_uring_prep_writev_fixed(struct io_uring_sqe *sqe,
                                int fd,
                                const struct iovec *iovecs,
                                unsigned nr_vecs,
                                __u64 offset,
                                int flags,
                                int buf_index);

DESCRIPTION

The io_uring_prep_writev_fixed(3) function prepares a vectored write request using fixed (registered) buffers. The submission queue entry sqe is setup to use the file descriptor fd to start writing nr_vecs iovecs from the file position offset.

The iovecs argument points to an array of iovec structures describing the write buffers. All buffers must be part of the registered buffer set at index buf_index, previously registered with io_uring_register_buffers(3).

The flags argument can contain any per-request flags, such as RWF_APPEND or other flags supported by pwritev2(2).

Using fixed buffers avoids the overhead of mapping buffers for each I/O operation, improving performance for applications that reuse the same buffers.

RETURN VALUE
None

ERRORS
The CQE res field will contain the result of the operation, the number of bytes written on success. On error, a negative errno value is returned.

NOTES
Despite accepting an array of iovec's with a size_t number of bytes each, this function can transfer at most INT_MAX bytes per call (the maximum for the underlying syscall interface).

SEE ALSO
io_uring_get_sqe(3), io_uring_submit(3), io_uring_prep_writev(3), io_uring_prep_writev2(3), io_uring_prep_write_fixed(3), io_uring_prep_readv_fixed(3), io_uring_register_buffers(3)